// 
// Copyright (c) 2002 David Eriksson <david@2good.nu>
// 
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
// DEALINGS IN THE SOFTWARE.
//
// $Id: desquirr.hpp,v 1.1.1.1 2002/06/20 18:00:44 twogood Exp $
#ifndef _DESQUIRR_HPP
#define _DESQUIRR_HPP

//
// C++ includes
//
#include <algorithm>
#include <iostream>
#include <list>
#include <map>
#include <stack>
#include <string>
#include <vector>

//
// Boost includes
//
#include <boost/shared_ptr.hpp>

//
// IDA includes
// 
#include <ida.hpp>
#include <idp.hpp>
#include <ua.hpp>
#include <funcs.hpp>
#include <bytes.hpp>
#include <typeinf.hpp>

//
// Forward declararions
//
class Call;
class ErasePool;
class Expression;
class Instruction;
class Node;
class Function;

//
// Typedefs
//
typedef boost::shared_ptr<ErasePool> ErasePool_ptr;

typedef boost::shared_ptr<Expression> Expression_ptr;
//typedef std::list<Expression_ptr>     Expression_list;
typedef std::vector<Expression_ptr>   Expression_vector;

typedef boost::shared_ptr<Instruction> Instruction_ptr;
typedef std::vector<Instruction_ptr>   Instruction_vector;
typedef std::list<Instruction_ptr>     Instruction_list;

typedef Instruction_vector Instruction_collection;

typedef std::stack<Instruction_list::iterator> Instruction_list_iterator_stack;

typedef std::pair    <unsigned short, ea_t> RegisterToAddress_pair;
typedef std::multimap<unsigned short, ea_t> RegisterToAddress_map;

typedef boost::shared_ptr<Node>  Node_ptr;
typedef std::list<Node_ptr>      Node_list;

typedef boost::shared_ptr<Function>  Function_ptr;
typedef std::list<Function_ptr>      Function_list;

typedef vector<insn_t> insn_vector;

#endif // _DESQUIRR_HPP

